diff --git a/target/linux/brcm63xx/patches-3.18/103-MIPS-BCM63XX-add-OHCI-EHCI-configuration-bits-to-com.patch b/target/linux/brcm63xx/patches-3.18/103-MIPS-BCM63XX-add-OHCI-EHCI-configuration-bits-to-com.patch
index 40bbe08..deda928 100644
--- a/target/linux/brcm63xx/patches-3.18/103-MIPS-BCM63XX-add-OHCI-EHCI-configuration-bits-to-com.patch
+++ b/target/linux/brcm63xx/patches-3.18/103-MIPS-BCM63XX-add-OHCI-EHCI-configuration-bits-to-com.patch
@@ -66,7 +66,7 @@ Signed-off-by: Florian Fainelli <florian@openwrt.org>
  
  	val = bcm_rset_readl(RSET_USBH_PRIV, USBH_PRIV_UTMI_CTL_6368_REG);
  	if (is_on)
-@@ -49,5 +61,90 @@ void bcm63xx_usb_priv_select_pullup(u32
+@@ -49,5 +61,90 @@ void bcm63xx_usb_priv_select_pullup(u32 
  	else
  		val |= (portmask << USBH_PRIV_UTMI_CTL_NODRIV_SHIFT);
  	bcm_rset_writel(RSET_USBH_PRIV, val, USBH_PRIV_UTMI_CTL_6368_REG);
diff --git a/target/linux/brcm63xx/patches-3.18/202-MTD-DEVICES-m25p80-use-parsers-if-provided-in-flash-.patch b/target/linux/brcm63xx/patches-3.18/202-MTD-DEVICES-m25p80-use-parsers-if-provided-in-flash-.patch
index b949694..180d842 100644
--- a/target/linux/brcm63xx/patches-3.18/202-MTD-DEVICES-m25p80-use-parsers-if-provided-in-flash-.patch
+++ b/target/linux/brcm63xx/patches-3.18/202-MTD-DEVICES-m25p80-use-parsers-if-provided-in-flash-.patch
@@ -11,7 +11,7 @@ Signed-off-by: Jonas Gorski <jonas.gorski@gmail.com>
 
 --- a/drivers/mtd/devices/m25p80.c
 +++ b/drivers/mtd/devices/m25p80.c
-@@ -246,7 +246,8 @@ static int m25p_probe(struct spi_device
+@@ -246,7 +246,8 @@ static int m25p_probe(struct spi_device 
  
  	ppdata.of_node = spi->dev.of_node;
  
diff --git a/target/linux/brcm63xx/patches-3.18/203-MTD-DEVICES-m25p80-add-support-for-limiting-reads.patch b/target/linux/brcm63xx/patches-3.18/203-MTD-DEVICES-m25p80-add-support-for-limiting-reads.patch
index 740fb2d..96c8c79 100644
--- a/target/linux/brcm63xx/patches-3.18/203-MTD-DEVICES-m25p80-add-support-for-limiting-reads.patch
+++ b/target/linux/brcm63xx/patches-3.18/203-MTD-DEVICES-m25p80-add-support-for-limiting-reads.patch
@@ -58,7 +58,7 @@ Signed-off-by: Jonas Gorski <jonas.gorski@gmail.com>
  static int m25p80_erase(struct spi_nor *nor, loff_t offset)
  {
  	struct m25p *flash = nor->priv;
-@@ -240,6 +264,9 @@ static int m25p_probe(struct spi_device
+@@ -240,6 +264,9 @@ static int m25p_probe(struct spi_device 
  	else
  		flash_name = spi->modalias;
  
diff --git a/target/linux/brcm63xx/patches-3.18/339-MIPS-BCM63XX-add-support-for-BCM63268.patch b/target/linux/brcm63xx/patches-3.18/339-MIPS-BCM63XX-add-support-for-BCM63268.patch
index 22ceeea..bee8a10 100644
--- a/target/linux/brcm63xx/patches-3.18/339-MIPS-BCM63XX-add-support-for-BCM63268.patch
+++ b/target/linux/brcm63xx/patches-3.18/339-MIPS-BCM63XX-add-support-for-BCM63268.patch
@@ -46,7 +46,7 @@ Signed-off-by: Jonas Gorski <jogo@openwrt.org>
  		val = bcm_mpi_readl(MPI_CSBASE_REG(0));
 --- a/arch/mips/bcm63xx/clk.c
 +++ b/arch/mips/bcm63xx/clk.c
-@@ -133,6 +133,8 @@ static void enetsw_set(struct clk *clk,
+@@ -133,6 +133,8 @@ static void enetsw_set(struct clk *clk, 
  				CKCTL_6368_SWPKT_USB_EN |
  				CKCTL_6368_SWPKT_SAR_EN,
  				enable);
@@ -107,7 +107,7 @@ Signed-off-by: Jonas Gorski <jogo@openwrt.org>
  }
  
  static struct clk clk_pcie = {
-@@ -386,9 +400,11 @@ struct clk *clk_get(struct device *dev,
+@@ -386,9 +400,11 @@ struct clk *clk_get(struct device *dev, 
  		return &clk_periph;
  	if ((BCMCPU_IS_3368() || BCMCPU_IS_6358()) && !strcmp(id, "pcm"))
  		return &clk_pcm;
@@ -328,7 +328,7 @@ Signed-off-by: Jonas Gorski <jogo@openwrt.org>
  /*
   * core reset bits
   */
-@@ -156,6 +170,10 @@ static const u32 bcm6368_reset_bits[] =
+@@ -156,6 +170,10 @@ static const u32 bcm6368_reset_bits[] = 
  	__GEN_RESET_BITS_TABLE(6368)
  };
  
diff --git a/target/linux/brcm63xx/patches-3.18/341-MIPS-BCM63XX-add-support-for-BCM6318.patch b/target/linux/brcm63xx/patches-3.18/341-MIPS-BCM63XX-add-support-for-BCM6318.patch
index ead4ee0..0bb2fa7 100644
--- a/target/linux/brcm63xx/patches-3.18/341-MIPS-BCM63XX-add-support-for-BCM6318.patch
+++ b/target/linux/brcm63xx/patches-3.18/341-MIPS-BCM63XX-add-support-for-BCM6318.patch
@@ -251,7 +251,7 @@ Subject: [PATCH 51/53] MIPS: BCM63XX: add support for BCM6318
  #define BCM6328_RESET_SPI	SOFTRESET_6328_SPI_MASK
  #define BCM6328_RESET_ENET	0
  #define BCM6328_RESET_USBH	SOFTRESET_6328_USBH_MASK
-@@ -147,6 +164,10 @@ static const u32 bcm3368_reset_bits[] =
+@@ -147,6 +164,10 @@ static const u32 bcm3368_reset_bits[] = 
  	__GEN_RESET_BITS_TABLE(3368)
  };
  
diff --git a/target/linux/brcm63xx/patches-3.18/343-MIPS-BCM63XX-add-PCIe-support-for-BCM6318.patch b/target/linux/brcm63xx/patches-3.18/343-MIPS-BCM63XX-add-PCIe-support-for-BCM6318.patch
index 3ac08b4..b923c1e 100644
--- a/target/linux/brcm63xx/patches-3.18/343-MIPS-BCM63XX-add-PCIe-support-for-BCM6318.patch
+++ b/target/linux/brcm63xx/patches-3.18/343-MIPS-BCM63XX-add-PCIe-support-for-BCM6318.patch
@@ -53,7 +53,7 @@ Subject: [PATCH 53/53] MIPS: BCM63XX: add PCIe support for BCM6318
  }
  
  static struct clk clk_pcie = {
-@@ -405,7 +422,7 @@ struct clk *clk_get(struct device *dev,
+@@ -405,7 +422,7 @@ struct clk *clk_get(struct device *dev, 
  	if ((BCMCPU_IS_6362() || BCMCPU_IS_6368() || BCMCPU_IS_63268()) &&
  	    !strcmp(id, "ipsec"))
  		return &clk_ipsec;
diff --git a/target/linux/brcm63xx/patches-3.18/346-MIPS-BCM63XX-USB-ENETSW-6318-clocks.patch b/target/linux/brcm63xx/patches-3.18/346-MIPS-BCM63XX-USB-ENETSW-6318-clocks.patch
index 384702c..d36c2bf 100644
--- a/target/linux/brcm63xx/patches-3.18/346-MIPS-BCM63XX-USB-ENETSW-6318-clocks.patch
+++ b/target/linux/brcm63xx/patches-3.18/346-MIPS-BCM63XX-USB-ENETSW-6318-clocks.patch
@@ -42,7 +42,7 @@
  
  	if (enable)
  		msleep(100);
-@@ -405,9 +413,9 @@ struct clk *clk_get(struct device *dev,
+@@ -405,9 +413,9 @@ struct clk *clk_get(struct device *dev, 
  		return &clk_enetsw;
  	if (!strcmp(id, "ephy"))
  		return &clk_ephy;
diff --git a/target/linux/brcm63xx/patches-3.18/355-MIPS-BCM63XX-allow-board-implementations-to-force-fl.patch b/target/linux/brcm63xx/patches-3.18/355-MIPS-BCM63XX-allow-board-implementations-to-force-fl.patch
index 7e408f6..b4ff86d 100644
--- a/target/linux/brcm63xx/patches-3.18/355-MIPS-BCM63XX-allow-board-implementations-to-force-fl.patch
+++ b/target/linux/brcm63xx/patches-3.18/355-MIPS-BCM63XX-allow-board-implementations-to-force-fl.patch
@@ -14,7 +14,7 @@ Signed-off-by: Jonas Gorski <jogo@openwrt.org>
 
 --- a/arch/mips/bcm63xx/dev-flash.c
 +++ b/arch/mips/bcm63xx/dev-flash.c
-@@ -57,6 +57,12 @@ static struct platform_device mtd_dev =
+@@ -57,6 +57,12 @@ static struct platform_device mtd_dev = 
  	},
  };
  
diff --git a/target/linux/brcm63xx/patches-3.18/356-MIPS-BCM63XX-move-fallback-sprom-support-into-its-ow.patch b/target/linux/brcm63xx/patches-3.18/356-MIPS-BCM63XX-move-fallback-sprom-support-into-its-ow.patch
index 450bc1d..d2fe588 100644
--- a/target/linux/brcm63xx/patches-3.18/356-MIPS-BCM63XX-move-fallback-sprom-support-into-its-ow.patch
+++ b/target/linux/brcm63xx/patches-3.18/356-MIPS-BCM63XX-move-fallback-sprom-support-into-its-ow.patch
@@ -20,7 +20,7 @@ Signed-off-by: Jonas Gorski <jogo@openwrt.org>
 
 --- a/arch/mips/bcm63xx/Makefile
 +++ b/arch/mips/bcm63xx/Makefile
-@@ -2,7 +2,7 @@ obj-y		+= clk.o cpu.o cs.o gpio.o irq.o
+@@ -2,7 +2,7 @@ obj-y		+= clk.o cpu.o cs.o gpio.o irq.o 
  		   setup.o timer.o dev-dsp.o dev-enet.o dev-flash.o \
  		   dev-pcmcia.o dev-rng.o dev-spi.o dev-hsspi.o dev-uart.o \
  		   dev-wdt.o dev-usb-ehci.o dev-usb-ohci.o dev-usb-usbd.o \
diff --git a/target/linux/brcm63xx/patches-3.18/359-MIPS-BCM63XX-allow-different-types-of-sprom.patch b/target/linux/brcm63xx/patches-3.18/359-MIPS-BCM63XX-allow-different-types-of-sprom.patch
index 0c4a9be..4e97005 100644
--- a/target/linux/brcm63xx/patches-3.18/359-MIPS-BCM63XX-allow-different-types-of-sprom.patch
+++ b/target/linux/brcm63xx/patches-3.18/359-MIPS-BCM63XX-allow-different-types-of-sprom.patch
@@ -23,7 +23,7 @@ Signed-off-by: Jonas Gorski <jogo@openwrt.org>
  	.revision		= 0x02,
  	.board_rev		= 0x17,
  	.country_code		= 0x0,
-@@ -43,6 +43,8 @@ static struct ssb_sprom bcm63xx_sprom =
+@@ -43,6 +43,8 @@ static struct ssb_sprom bcm63xx_sprom = 
  	.boardflags_hi		= 0x0000,
  };
  
diff --git a/target/linux/brcm63xx/patches-3.18/362-MIPS-BCM63XX-also-register-a-fallback-sprom-for-bcma.patch b/target/linux/brcm63xx/patches-3.18/362-MIPS-BCM63XX-also-register-a-fallback-sprom-for-bcma.patch
index 6475f9f..f1093a2 100644
--- a/target/linux/brcm63xx/patches-3.18/362-MIPS-BCM63XX-also-register-a-fallback-sprom-for-bcma.patch
+++ b/target/linux/brcm63xx/patches-3.18/362-MIPS-BCM63XX-also-register-a-fallback-sprom-for-bcma.patch
@@ -49,7 +49,7 @@ Signed-off-by: Jonas Gorski <jogo@openwrt.org>
  static __initconst u16 bcm4306_sprom[] = {
  	0x4001, 0x0000, 0x0453, 0x14e4, 0x4320, 0x8000, 0x0002, 0x0002,
  	0x1000, 0x1800, 0x0000, 0x0000, 0xffff, 0xffff, 0xffff, 0xffff,
-@@ -158,10 +159,12 @@ static __initconst u16 bcm43222_sprom[]
+@@ -158,10 +159,12 @@ static __initconst u16 bcm43222_sprom[] 
  	0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff,
  	0xffff, 0xffff, 0xffff, 0x0008,
  };
diff --git a/target/linux/brcm63xx/patches-3.18/363-MIPS-BCM63XX-add-BCMA-based-sprom-templates.patch b/target/linux/brcm63xx/patches-3.18/363-MIPS-BCM63XX-add-BCMA-based-sprom-templates.patch
index 5c0abb9..d3d58eb 100644
--- a/target/linux/brcm63xx/patches-3.18/363-MIPS-BCM63XX-add-BCMA-based-sprom-templates.patch
+++ b/target/linux/brcm63xx/patches-3.18/363-MIPS-BCM63XX-add-BCMA-based-sprom-templates.patch
@@ -14,7 +14,7 @@ Signed-off-by: Jonas Gorski <jogo@openwrt.org>
 
 --- a/arch/mips/bcm63xx/sprom.c
 +++ b/arch/mips/bcm63xx/sprom.c
-@@ -161,6 +161,226 @@ static __initconst u16 bcm43222_sprom[]
+@@ -161,6 +161,226 @@ static __initconst u16 bcm43222_sprom[] 
  };
  #endif /* CONFIG_SSB_PCIHOST */
  
diff --git a/target/linux/brcm63xx/patches-3.18/366-MIPS-add-support-for-vmlinux.bin-appended-DTB.patch b/target/linux/brcm63xx/patches-3.18/366-MIPS-add-support-for-vmlinux.bin-appended-DTB.patch
index ff455dd..4e6296e 100644
--- a/target/linux/brcm63xx/patches-3.18/366-MIPS-add-support-for-vmlinux.bin-appended-DTB.patch
+++ b/target/linux/brcm63xx/patches-3.18/366-MIPS-add-support-for-vmlinux.bin-appended-DTB.patch
@@ -70,7 +70,7 @@ Completely untested on anything except MIPS32 / big endian.
  menu "Executable file formats"
 --- a/arch/mips/kernel/head.S
 +++ b/arch/mips/kernel/head.S
-@@ -100,6 +100,22 @@ NESTED(kernel_entry, 16, sp)			# kernel
+@@ -100,6 +100,22 @@ NESTED(kernel_entry, 16, sp)			# kernel 
  	jr	t0
  0:
  
@@ -93,7 +93,7 @@ Completely untested on anything except MIPS32 / big endian.
  	PTR_LA		t0, __bss_start		# clear .bss
  	LONG_S		zero, (t0)
  	PTR_LA		t1, __bss_stop - LONGSIZE
-@@ -113,6 +129,10 @@ NESTED(kernel_entry, 16, sp)			# kernel
+@@ -113,6 +129,10 @@ NESTED(kernel_entry, 16, sp)			# kernel 
  	LONG_S		a2, fw_arg2
  	LONG_S		a3, fw_arg3
  
diff --git a/target/linux/brcm63xx/patches-3.18/376-net-bcm63xx_enet-use-named-gpio-for-ephy-reset-gpio.patch b/target/linux/brcm63xx/patches-3.18/376-net-bcm63xx_enet-use-named-gpio-for-ephy-reset-gpio.patch
index 6d19cc0..5436ad3 100644
--- a/target/linux/brcm63xx/patches-3.18/376-net-bcm63xx_enet-use-named-gpio-for-ephy-reset-gpio.patch
+++ b/target/linux/brcm63xx/patches-3.18/376-net-bcm63xx_enet-use-named-gpio-for-ephy-reset-gpio.patch
@@ -18,7 +18,7 @@ Allow using a named optional gpio for ephy reset gpio registration.
  
  #include <bcm63xx_dev_enet.h>
  #include "bcm63xx_enet.h"
-@@ -2848,10 +2849,15 @@ static int bcm_enet_shared_probe(struct
+@@ -2848,10 +2849,15 @@ static int bcm_enet_shared_probe(struct 
  {
  	struct resource *res;
  	void __iomem *p[3];
@@ -34,7 +34,7 @@ Allow using a named optional gpio for ephy reset gpio registration.
  	for (i = 0; i < 3; i++) {
  		res = platform_get_resource(pdev, IORESOURCE_MEM, i);
  		p[i] = devm_ioremap_resource(&pdev->dev, res);
-@@ -2861,6 +2867,9 @@ static int bcm_enet_shared_probe(struct
+@@ -2861,6 +2867,9 @@ static int bcm_enet_shared_probe(struct 
  
  	memcpy(bcm_enet_shared_base, p, sizeof(bcm_enet_shared_base));
  
diff --git a/target/linux/brcm63xx/patches-3.18/414-MTD-m25p80-allow-passing-pp_data.patch b/target/linux/brcm63xx/patches-3.18/414-MTD-m25p80-allow-passing-pp_data.patch
index b7bf57f..b218e46 100644
--- a/target/linux/brcm63xx/patches-3.18/414-MTD-m25p80-allow-passing-pp_data.patch
+++ b/target/linux/brcm63xx/patches-3.18/414-MTD-m25p80-allow-passing-pp_data.patch
@@ -10,7 +10,7 @@ Subject: [PATCH 64/79] MTD: m25p80: allow passing pp_data
 
 --- a/drivers/mtd/devices/m25p80.c
 +++ b/drivers/mtd/devices/m25p80.c
-@@ -267,6 +267,9 @@ static int m25p_probe(struct spi_device
+@@ -267,6 +267,9 @@ static int m25p_probe(struct spi_device 
  	if (data)
  		flash->max_transfer_len = data->max_transfer_len;
  
diff --git a/target/linux/brcm63xx/patches-3.18/416-BCM63XX-add-a-fixup-for-ath9k-devices.patch b/target/linux/brcm63xx/patches-3.18/416-BCM63XX-add-a-fixup-for-ath9k-devices.patch
index 7a7c825..b36c1b8 100644
--- a/target/linux/brcm63xx/patches-3.18/416-BCM63XX-add-a-fixup-for-ath9k-devices.patch
+++ b/target/linux/brcm63xx/patches-3.18/416-BCM63XX-add-a-fixup-for-ath9k-devices.patch
@@ -13,7 +13,7 @@ Subject: [PATCH 61/72] BCM63XX: add a fixup for ath9k devices
 
 --- a/arch/mips/bcm63xx/Makefile
 +++ b/arch/mips/bcm63xx/Makefile
-@@ -2,7 +2,7 @@ obj-y		+= clk.o cpu.o cs.o gpio.o irq.o
+@@ -2,7 +2,7 @@ obj-y		+= clk.o cpu.o cs.o gpio.o irq.o 
  		   setup.o timer.o dev-dsp.o dev-enet.o dev-flash.o \
  		   dev-pcmcia.o dev-rng.o dev-spi.o dev-hsspi.o dev-uart.o \
  		   dev-wdt.o dev-usb-ehci.o dev-usb-ohci.o dev-usb-usbd.o \
diff --git a/target/linux/brcm63xx/patches-3.18/422-BCM63XX-add-a-fixup-for-rt2x00-devices.patch b/target/linux/brcm63xx/patches-3.18/422-BCM63XX-add-a-fixup-for-rt2x00-devices.patch
index bff489b..a0b080e 100644
--- a/target/linux/brcm63xx/patches-3.18/422-BCM63XX-add-a-fixup-for-rt2x00-devices.patch
+++ b/target/linux/brcm63xx/patches-3.18/422-BCM63XX-add-a-fixup-for-rt2x00-devices.patch
@@ -17,7 +17,7 @@ Subject: [PATCH 72/72] 446-BCM63XX-add-a-fixup-for-rt2x00-devices
 
 --- a/arch/mips/bcm63xx/Makefile
 +++ b/arch/mips/bcm63xx/Makefile
-@@ -2,7 +2,7 @@ obj-y		+= clk.o cpu.o cs.o gpio.o irq.o
+@@ -2,7 +2,7 @@ obj-y		+= clk.o cpu.o cs.o gpio.o irq.o 
  		   setup.o timer.o dev-dsp.o dev-enet.o dev-flash.o \
  		   dev-pcmcia.o dev-rng.o dev-spi.o dev-hsspi.o dev-uart.o \
  		   dev-wdt.o dev-usb-ehci.o dev-usb-ohci.o dev-usb-usbd.o \
diff --git a/target/linux/brcm63xx/patches-3.18/560-board_963268gu_p300.patch b/target/linux/brcm63xx/patches-3.18/560-board_963268gu_p300.patch
index 8eef982..9c0f7b7 100644
--- a/target/linux/brcm63xx/patches-3.18/560-board_963268gu_p300.patch
+++ b/target/linux/brcm63xx/patches-3.18/560-board_963268gu_p300.patch
@@ -79,7 +79,7 @@
  	{ .compatible = "brcm,bcm96368mvwg", .data = &board_96368mvwg, },
  #endif
  #ifdef CONFIG_BCM63XX_CPU_63268
-+ 	{ .compatible = "brcm,bcm963268bu_p300", .data = &board_963268bu_p300, },
++	{ .compatible = "brcm,bcm963268bu_p300", .data = &board_963268bu_p300, },
  	{ .compatible = "inteno,vg50", .data = &board_vw6339gu, },
  #endif
  #endif /* CONFIG_OF */
diff --git a/target/linux/brcm63xx/patches-3.18/561-board_WAP-5813n.patch b/target/linux/brcm63xx/patches-3.18/561-board_WAP-5813n.patch
index 27d925c..2be0091 100644
--- a/target/linux/brcm63xx/patches-3.18/561-board_WAP-5813n.patch
+++ b/target/linux/brcm63xx/patches-3.18/561-board_WAP-5813n.patch
@@ -91,4 +91,4 @@
 +	{ .compatible = "comtrend,wap-5813n", .data = &board_WAP5813n, },
  #endif
  #ifdef CONFIG_BCM63XX_CPU_63268
-  	{ .compatible = "brcm,bcm963268bu_p300", .data = &board_963268bu_p300, },
+ 	{ .compatible = "brcm,bcm963268bu_p300", .data = &board_963268bu_p300, },
diff --git a/target/linux/brcm63xx/patches-3.18/564-board_P870HW-51a_v2.patch b/target/linux/brcm63xx/patches-3.18/564-board_P870HW-51a_v2.patch
index bc2b115..8ffc842 100644
--- a/target/linux/brcm63xx/patches-3.18/564-board_P870HW-51a_v2.patch
+++ b/target/linux/brcm63xx/patches-3.18/564-board_P870HW-51a_v2.patch
@@ -65,4 +65,4 @@
 +	{ .compatible = "zyxel,p870hw-51a-v2", .data = &board_P870HW51A_V2, },
  #endif
  #ifdef CONFIG_BCM63XX_CPU_63268
-  	{ .compatible = "brcm,bcm963268bu_p300", .data = &board_963268bu_p300, },
+ 	{ .compatible = "brcm,bcm963268bu_p300", .data = &board_963268bu_p300, },
diff --git a/target/linux/brcm63xx/profiles/broadcom.mk b/target/linux/brcm63xx/profiles/broadcom.mk
index a8d8bfb..8a06a2d 100644
--- a/target/linux/brcm63xx/profiles/broadcom.mk
+++ b/target/linux/brcm63xx/profiles/broadcom.mk
@@ -24,7 +24,7 @@ endef
 $(eval $(call Profile,BCM96318REF_P300))
 
 define Profile/BCM963268BU_P300
-  NAME:=Broadcom BCM96328BU_P300 reference board
+  NAME:=Broadcom BCM963268BU_P300 reference board
   PACKAGES:= kmod-usb-ohci kmod-usb2 kmod-bcm63xx-udc
 endef
 define Profile/BCM963268BU_P300/Description